#include "sensor_cli.h"



int settings_set_inpl(struct bt_mesh_model *model, const char *name,
                     size_t len_rd, settings_read_cb read_cb, 
                     void *cb_arg)
{
    struct tranciever_client *chat = model->user_data;

	if (name) {
		return -ENOENT;
	}

    //I don't unterstand this part
    /*
	ssize_t bytes = read_cb(cb_arg, &chat->presence,
				sizeof(chat->presence));
	if (bytes < 0) {
		return bytes;
	}

	if (bytes != 0 && bytes != sizeof(chat->presence)) {
		return -EINVAL;
	}
    */

	return 0;
}


int start_inpl(struct bt_mesh_model *model)
{
    struct tranciever_client *pTrance = model->user_data;

    // Call start function if its available
    if(pTrance->handlers->start)
        pTrance->handlers->start(pTrance);
    
    return 0;
}


int init_inpl(struct bt_mesh_model *model)
{

    struct tranciever_client *pTranc = model->user_data;
    pTranc->model = model;

    ////////////////////////
    //Initialize net buffer 
    ////////////////////////
    net_buf_simple_init_with_data(&pTranc->pub_msg, pTranc->buf, sizeof(pTranc->buf));
    pTranc->pub.msg = &pTranc->pub_msg;
    
    //Maybe implement sometimes
    //pTranc->pub.update = 
    return 0;
}


void reset_inpl(struct bt_mesh_model *model)
{
    struct tranciever_client *pTrance = model->user_data;

    //Store to persistent storage
    if (IS_ENABLED(CONFIG_BT_SETTINGS)) {
		(void) bt_mesh_model_data_store(model, true, NULL, NULL, 0);
	}
}


int tranciever_message_send(const struct tranciever_client *tranciever, uint16_t addr, const uint8_t *msg)
{
    struct bt_mesh_msg_ctx ctx = {
        .addr = addr,
        .app_idx = tranciever->model->keys[0],
        .send_ttl = BT_MESH_TTL_DEFAULT,
        .send_rel = false,
    };

    // Define TX_Buffer
    BT_MESH_MODEL_BUF_DEFINE(buf, BT_MESH_SENSOR_INFO_PUBLISH_OP_MESSAGE,
				            MESSAGE_PUBLISH_LEN);

	bt_mesh_model_msg_init(&buf, BT_MESH_SENSOR_INFO_PUBLISH_OP_MESSAGE);

	net_buf_simple_add_mem(&buf, msg, strnlen(msg, MESSAGE_PUBLISH_LEN));
	net_buf_simple_add_u8(&buf, '\0');

	return bt_mesh_model_send(tranciever->model, &ctx, &buf, NULL, NULL);

}


const struct bt_mesh_model_op _transceiver_model_op[] = {
	BT_MESH_MODEL_OP_END,
};


const struct bt_mesh_model_cb tranciever_client_cb = {
    .init = init_inpl,
    .reset = reset_inpl,
    .settings_set = settings_set_inpl,
    .start = start_inpl,
};